/*
 * $Id$
 */

package org.codehaus.mojo.taglist.output;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * The file a tag was found within.
 * 
 * @version $Revision$ $Date$
 */
public class TagListXMLFile implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field name.
     */
    private String name;

    /**
     * Field count.
     */
    private String count;

    /**
     * Field comments.
     */
    private java.util.List comments;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addComment.
     * 
     * @param tagListXMLComment
     */
    public void addComment( TagListXMLComment tagListXMLComment )
    {
        if ( !(tagListXMLComment instanceof TagListXMLComment) )
        {
            throw new ClassCastException( "TagListXMLFile.addComments(tagListXMLComment) parameter must be instanceof " + TagListXMLComment.class.getName() );
        }
        getComments().add( tagListXMLComment );
    } //-- void addComment( TagListXMLComment ) 

    /**
     * Method getComments.
     * 
     * @return java.util.List
     */
    public java.util.List getComments()
    {
        if ( this.comments == null )
        {
            this.comments = new java.util.ArrayList();
        }
    
        return this.comments;
    } //-- java.util.List getComments() 

    /**
     * Get the count field.
     * 
     * @return String
     */
    public String getCount()
    {
        return this.count;
    } //-- String getCount() 

    /**
     * Get the name field.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName() 

    /**
     * Method removeComment.
     * 
     * @param tagListXMLComment
     */
    public void removeComment( TagListXMLComment tagListXMLComment )
    {
        if ( !(tagListXMLComment instanceof TagListXMLComment) )
        {
            throw new ClassCastException( "TagListXMLFile.removeComments(tagListXMLComment) parameter must be instanceof " + TagListXMLComment.class.getName() );
        }
        getComments().remove( tagListXMLComment );
    } //-- void removeComment( TagListXMLComment ) 

    /**
     * Set the comments field.
     * 
     * @param comments
     */
    public void setComments( java.util.List comments )
    {
        this.comments = comments;
    } //-- void setComments( java.util.List ) 

    /**
     * Set the count field.
     * 
     * @param count
     */
    public void setCount( String count )
    {
        this.count = count;
    } //-- void setCount( String ) 

    /**
     * Set the name field.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String ) 


    private String modelEncoding = "UTF-8";

    /**
     * Set an encoding used for reading/writing the model.
     *
     * @param modelEncoding the encoding used when reading/writing the model.
     */
    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    /**
     * @return the current encoding used when reading/writing this model.
     */
    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
