/*
 * $Id$
 */

package org.codehaus.mojo.taglist.output;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * A specific tag defined by the user.
 * 
 * @version $Revision$ $Date$
 */
public class TagListXMLTag implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The name of the tag.
     */
    private String name;

    /**
     * Field count.
     */
    private String count;

    /**
     * Field files.
     */
    private java.util.List files;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addFile.
     * 
     * @param tagListXMLFile
     */
    public void addFile( TagListXMLFile tagListXMLFile )
    {
        if ( !(tagListXMLFile instanceof TagListXMLFile) )
        {
            throw new ClassCastException( "TagListXMLTag.addFiles(tagListXMLFile) parameter must be instanceof " + TagListXMLFile.class.getName() );
        }
        getFiles().add( tagListXMLFile );
    } //-- void addFile( TagListXMLFile ) 

    /**
     * Get the count field.
     * 
     * @return String
     */
    public String getCount()
    {
        return this.count;
    } //-- String getCount() 

    /**
     * Method getFiles.
     * 
     * @return java.util.List
     */
    public java.util.List getFiles()
    {
        if ( this.files == null )
        {
            this.files = new java.util.ArrayList();
        }
    
        return this.files;
    } //-- java.util.List getFiles() 

    /**
     * Get the name of the tag.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName() 

    /**
     * Method removeFile.
     * 
     * @param tagListXMLFile
     */
    public void removeFile( TagListXMLFile tagListXMLFile )
    {
        if ( !(tagListXMLFile instanceof TagListXMLFile) )
        {
            throw new ClassCastException( "TagListXMLTag.removeFiles(tagListXMLFile) parameter must be instanceof " + TagListXMLFile.class.getName() );
        }
        getFiles().remove( tagListXMLFile );
    } //-- void removeFile( TagListXMLFile ) 

    /**
     * Set the count field.
     * 
     * @param count
     */
    public void setCount( String count )
    {
        this.count = count;
    } //-- void setCount( String ) 

    /**
     * Set the files field.
     * 
     * @param files
     */
    public void setFiles( java.util.List files )
    {
        this.files = files;
    } //-- void setFiles( java.util.List ) 

    /**
     * Set the name of the tag.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String ) 


    private String modelEncoding = "UTF-8";

    /**
     * Set an encoding used for reading/writing the model.
     *
     * @param modelEncoding the encoding used when reading/writing the model.
     */
    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    /**
     * @return the current encoding used when reading/writing this model.
     */
    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
